"""
This file is generated by the openapi-python-client tool via the generate_api_client.py script

It is a customized template from the openapi-python-client tool's default template:
https://github.com/openapi-generators/openapi-python-client/blob/861ef5622f10fc96d240dc9becb0edf94e61446c/openapi_python_client/templates/model.py.jinja

The main change is:
- Fix typing issues
"""

# flake8: noqa: C901

from typing import Any, List, Type, TypeVar, Union, cast

from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

T = TypeVar("T", bound="LabeledMemoryMetrics")


@_attrs_define
class LabeledMemoryMetrics:
    """Metrics computed for a labeled memory.

    Attributes:
        neighbor_label_logits (Union[List[float], None, Unset]):
        neighbor_predicted_label (Union[None, Unset, int]):
        neighbor_predicted_label_ambiguity (Union[None, Unset, float]):
        neighbor_predicted_label_confidence (Union[None, Unset, float]):
        current_label_neighbor_confidence (Union[None, Unset, float]):
        normalized_neighbor_label_entropy (Union[None, Unset, float]):
        neighbor_predicted_label_matches_current_label (Union[None, Unset, bool]):
        is_duplicate (Union[None, Unset, bool]):
        duplicate_memory_ids (Union[List[str], None, Unset]):
    """

    neighbor_label_logits: Union[List[float], None, Unset] = UNSET
    neighbor_predicted_label: Union[None, Unset, int] = UNSET
    neighbor_predicted_label_ambiguity: Union[None, Unset, float] = UNSET
    neighbor_predicted_label_confidence: Union[None, Unset, float] = UNSET
    current_label_neighbor_confidence: Union[None, Unset, float] = UNSET
    normalized_neighbor_label_entropy: Union[None, Unset, float] = UNSET
    neighbor_predicted_label_matches_current_label: Union[None, Unset, bool] = UNSET
    is_duplicate: Union[None, Unset, bool] = UNSET
    duplicate_memory_ids: Union[List[str], None, Unset] = UNSET
    additional_properties: dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> dict[str, Any]:
        neighbor_label_logits: Union[List[float], None, Unset]
        if isinstance(self.neighbor_label_logits, Unset):
            neighbor_label_logits = UNSET
        elif isinstance(self.neighbor_label_logits, list):
            neighbor_label_logits = self.neighbor_label_logits

        else:
            neighbor_label_logits = self.neighbor_label_logits

        neighbor_predicted_label: Union[None, Unset, int]
        if isinstance(self.neighbor_predicted_label, Unset):
            neighbor_predicted_label = UNSET
        else:
            neighbor_predicted_label = self.neighbor_predicted_label

        neighbor_predicted_label_ambiguity: Union[None, Unset, float]
        if isinstance(self.neighbor_predicted_label_ambiguity, Unset):
            neighbor_predicted_label_ambiguity = UNSET
        else:
            neighbor_predicted_label_ambiguity = self.neighbor_predicted_label_ambiguity

        neighbor_predicted_label_confidence: Union[None, Unset, float]
        if isinstance(self.neighbor_predicted_label_confidence, Unset):
            neighbor_predicted_label_confidence = UNSET
        else:
            neighbor_predicted_label_confidence = self.neighbor_predicted_label_confidence

        current_label_neighbor_confidence: Union[None, Unset, float]
        if isinstance(self.current_label_neighbor_confidence, Unset):
            current_label_neighbor_confidence = UNSET
        else:
            current_label_neighbor_confidence = self.current_label_neighbor_confidence

        normalized_neighbor_label_entropy: Union[None, Unset, float]
        if isinstance(self.normalized_neighbor_label_entropy, Unset):
            normalized_neighbor_label_entropy = UNSET
        else:
            normalized_neighbor_label_entropy = self.normalized_neighbor_label_entropy

        neighbor_predicted_label_matches_current_label: Union[None, Unset, bool]
        if isinstance(self.neighbor_predicted_label_matches_current_label, Unset):
            neighbor_predicted_label_matches_current_label = UNSET
        else:
            neighbor_predicted_label_matches_current_label = self.neighbor_predicted_label_matches_current_label

        is_duplicate: Union[None, Unset, bool]
        if isinstance(self.is_duplicate, Unset):
            is_duplicate = UNSET
        else:
            is_duplicate = self.is_duplicate

        duplicate_memory_ids: Union[List[str], None, Unset]
        if isinstance(self.duplicate_memory_ids, Unset):
            duplicate_memory_ids = UNSET
        elif isinstance(self.duplicate_memory_ids, list):
            duplicate_memory_ids = self.duplicate_memory_ids

        else:
            duplicate_memory_ids = self.duplicate_memory_ids

        field_dict: dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if neighbor_label_logits is not UNSET:
            field_dict["neighbor_label_logits"] = neighbor_label_logits
        if neighbor_predicted_label is not UNSET:
            field_dict["neighbor_predicted_label"] = neighbor_predicted_label
        if neighbor_predicted_label_ambiguity is not UNSET:
            field_dict["neighbor_predicted_label_ambiguity"] = neighbor_predicted_label_ambiguity
        if neighbor_predicted_label_confidence is not UNSET:
            field_dict["neighbor_predicted_label_confidence"] = neighbor_predicted_label_confidence
        if current_label_neighbor_confidence is not UNSET:
            field_dict["current_label_neighbor_confidence"] = current_label_neighbor_confidence
        if normalized_neighbor_label_entropy is not UNSET:
            field_dict["normalized_neighbor_label_entropy"] = normalized_neighbor_label_entropy
        if neighbor_predicted_label_matches_current_label is not UNSET:
            field_dict["neighbor_predicted_label_matches_current_label"] = (
                neighbor_predicted_label_matches_current_label
            )
        if is_duplicate is not UNSET:
            field_dict["is_duplicate"] = is_duplicate
        if duplicate_memory_ids is not UNSET:
            field_dict["duplicate_memory_ids"] = duplicate_memory_ids

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: dict[str, Any]) -> T:
        d = src_dict.copy()

        def _parse_neighbor_label_logits(data: object) -> Union[List[float], None, Unset]:
            if data is None:
                return data
            if isinstance(data, Unset):
                return data
            try:
                if not isinstance(data, list):
                    raise TypeError()
                neighbor_label_logits_type_0 = cast(List[float], data)

                return neighbor_label_logits_type_0
            except:  # noqa: E722
                pass
            return cast(Union[List[float], None, Unset], data)

        neighbor_label_logits = _parse_neighbor_label_logits(d.pop("neighbor_label_logits", UNSET))

        def _parse_neighbor_predicted_label(data: object) -> Union[None, Unset, int]:
            if data is None:
                return data
            if isinstance(data, Unset):
                return data
            return cast(Union[None, Unset, int], data)

        neighbor_predicted_label = _parse_neighbor_predicted_label(d.pop("neighbor_predicted_label", UNSET))

        def _parse_neighbor_predicted_label_ambiguity(data: object) -> Union[None, Unset, float]:
            if data is None:
                return data
            if isinstance(data, Unset):
                return data
            return cast(Union[None, Unset, float], data)

        neighbor_predicted_label_ambiguity = _parse_neighbor_predicted_label_ambiguity(
            d.pop("neighbor_predicted_label_ambiguity", UNSET)
        )

        def _parse_neighbor_predicted_label_confidence(data: object) -> Union[None, Unset, float]:
            if data is None:
                return data
            if isinstance(data, Unset):
                return data
            return cast(Union[None, Unset, float], data)

        neighbor_predicted_label_confidence = _parse_neighbor_predicted_label_confidence(
            d.pop("neighbor_predicted_label_confidence", UNSET)
        )

        def _parse_current_label_neighbor_confidence(data: object) -> Union[None, Unset, float]:
            if data is None:
                return data
            if isinstance(data, Unset):
                return data
            return cast(Union[None, Unset, float], data)

        current_label_neighbor_confidence = _parse_current_label_neighbor_confidence(
            d.pop("current_label_neighbor_confidence", UNSET)
        )

        def _parse_normalized_neighbor_label_entropy(data: object) -> Union[None, Unset, float]:
            if data is None:
                return data
            if isinstance(data, Unset):
                return data
            return cast(Union[None, Unset, float], data)

        normalized_neighbor_label_entropy = _parse_normalized_neighbor_label_entropy(
            d.pop("normalized_neighbor_label_entropy", UNSET)
        )

        def _parse_neighbor_predicted_label_matches_current_label(data: object) -> Union[None, Unset, bool]:
            if data is None:
                return data
            if isinstance(data, Unset):
                return data
            return cast(Union[None, Unset, bool], data)

        neighbor_predicted_label_matches_current_label = _parse_neighbor_predicted_label_matches_current_label(
            d.pop("neighbor_predicted_label_matches_current_label", UNSET)
        )

        def _parse_is_duplicate(data: object) -> Union[None, Unset, bool]:
            if data is None:
                return data
            if isinstance(data, Unset):
                return data
            return cast(Union[None, Unset, bool], data)

        is_duplicate = _parse_is_duplicate(d.pop("is_duplicate", UNSET))

        def _parse_duplicate_memory_ids(data: object) -> Union[List[str], None, Unset]:
            if data is None:
                return data
            if isinstance(data, Unset):
                return data
            try:
                if not isinstance(data, list):
                    raise TypeError()
                duplicate_memory_ids_type_0 = cast(List[str], data)

                return duplicate_memory_ids_type_0
            except:  # noqa: E722
                pass
            return cast(Union[List[str], None, Unset], data)

        duplicate_memory_ids = _parse_duplicate_memory_ids(d.pop("duplicate_memory_ids", UNSET))

        labeled_memory_metrics = cls(
            neighbor_label_logits=neighbor_label_logits,
            neighbor_predicted_label=neighbor_predicted_label,
            neighbor_predicted_label_ambiguity=neighbor_predicted_label_ambiguity,
            neighbor_predicted_label_confidence=neighbor_predicted_label_confidence,
            current_label_neighbor_confidence=current_label_neighbor_confidence,
            normalized_neighbor_label_entropy=normalized_neighbor_label_entropy,
            neighbor_predicted_label_matches_current_label=neighbor_predicted_label_matches_current_label,
            is_duplicate=is_duplicate,
            duplicate_memory_ids=duplicate_memory_ids,
        )

        labeled_memory_metrics.additional_properties = d
        return labeled_memory_metrics

    @property
    def additional_keys(self) -> list[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
